#!/usr/bin/perl
use warnings;
use strict;

package MyBot;
use Time::Local;
use DBI;
use POSIX;
use base qw( Bot::BasicBot );
use LWP::Simple;
use JSON;

my $channel = "#jkdf2";
my $platform = "mysql";
my $host = "localhost";
my $database = "jediknight";
my $user = "AcidRain";
my $pw = "x";
my $HelpPage = "Http://www.jkdf2.net/index.php?page=JKBot";
my $FloodProtection = 3; #seconds
my $dsn = "dbi:mysql:$database:localhost:3306";
my $connect;
my $NowTime = GetTime();
my $LastTime = $NowTime + 3;
my $ColorCode = "4";
# the 'said' callback gets called when someone says something in
# earshot of the bot.
sub LogToFile {
	my ($TextToLog) = @_;
	my($day, $month, $year)=(localtime)[3,4,5];
	my $LogFile = ($month+1) . "-" . $day . "-" . ($year+1900) . ".txt";
	if (open (MYFILE, '>> /var/www/jkdf2/JKBot/JKArchive/JKLog/' . $LogFile)) { ;
		$TextToLog =~ s/<AcidRain>//g;
		print MYFILE $TextToLog . "\n";
		close (MYFILE); 
	} else {
		print "Couldn't open log file: $LogFile\n";
	}
}
sub CheckIp {
	my ($ip) = @_;
	if(substr($ip, 0, 3) =~ "127") { return "false"; }
	if(substr($ip, 0, 3) =~ "192") { return "false"; }
	if($ip=~/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/ &&(($1<=255  && $2<=255 && $3<=255  &&$4<=255 ))) {
		return "true";
	} else {
		return "false";
	}
}

sub GetTime {
	return time;
}

sub LastSeen {
	my ($nick) = @_;
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	$year += 1900;
	$mon += 1;
	my $now_time = "$mon/$mday/$year $hour:$min:$sec";
		my $connect = DBI->connect($dsn, $user, $pw);
		my $query = "SELECT id FROM users WHERE username='$nick'";
		my $query_handle = $connect->prepare($query);
		$query_handle->execute();
		my @result = $query_handle->fetchrow_array();
		if(!(@result)) {
			$query = "INSERT INTO users (username, userbio, lastseen) VALUES ('$nick', 'no data', '$now_time')";
			$query_handle = $connect->prepare($query);
			$query_handle->execute();
			$query_handle->finish;
			$connect->disconnect();
		} else {
			my $resultid = int($result[0]);
			$query = "UPDATE users SET lastseen='$now_time' WHERE id='$resultid'";
			$query_handle = $connect->prepare($query);
			$query_handle->execute();
			$query_handle->finish;
			$connect->disconnect();
		}
	return $now_time;
}

sub chanpart {
 my ($self, $message) = @_;
 my $WhoParted = $message->{who};
 LogToFile("[" . localtime(time) . "] -----" . $WhoParted . " left channel.");
 return;
}

sub chanjoin {
 my ($self, $message) = @_;
 my $WhoJoined = $message->{who};
 LogToFile("[" . localtime(time) . "] -----" . $WhoJoined . " joined channel.");
	$connect = DBI->connect($dsn, $user, $pw);
 	my $query = "SELECT * FROM msg WHERE nicktomsg='$WhoJoined'";
	my $query_handle = $connect->prepare($query);
	$query_handle->execute();
	my @result = $query_handle->fetchrow_array();
	if(@result) {
		$LastTime = GetTime();
	 	$query = "DELETE FROM msg WHERE nicktomsg='$WhoJoined'";
		$query_handle = $connect->prepare($query);
		$query_handle->execute();
		$query_handle->finish;
		$connect->disconnect();
		return $ColorCode . "Msg From: $result[1]: $result[3]";
	} else {
		$query_handle->finish;
		$connect->disconnect();
		return;
	}
}

sub said {
 my ($self, $message) = @_;
 my $query = ""; #sql query is loaded into this variable
 my $query_handle = ""; #where query gets executed
 my $result; #results from query
 my $resultid; #id result from query
 my $WhoSaid = $message->{who};
 my $text = $message->{body};
 $text =~ s/[^a-zA-Z0-9@!._<>{}?:\/#; -]*//g;

LogToFile("[" . localtime(time) . "] <" . $WhoSaid . "> " . $text);

#This is for flood protection
 if (substr($text, 0, 1) =~ "!") {
 $NowTime = GetTime();
 my $Diff = $NowTime-$LastTime;
 if($Diff < $FloodProtection) { print "Flood Protection\n"; return; } #exit subroutine with flood protection
 
 }
#END OF FLOOD PROTECTION
	#FIRST SUPERUSER COMMANDS:
	print $WhoSaid . "(" . LastSeen($WhoSaid) . ")" . "> " . $text . "\n";
	if($WhoSaid eq "AcidRain") {
		if($text =~ "!shutdown") {
			print "\nShutting down bot...\n";
			$self->shutdown('Killed.');
		}
	}

	#!update command
	if (lc(substr($text, 0, 8)) =~ "!update ") {
		(my $command, my $NickToUpdate, my $UpdateText) = split(/\s+/, $text, 3); 
		if(length($UpdateText) < 2) { return $ColorCode . "Error: View $HelpPage"; }
		$connect = DBI->connect($dsn, $user, $pw);
		$query = "SELECT id FROM users WHERE username='$NickToUpdate'";
		$query_handle = $connect->prepare($query);
		$query_handle->execute();
		my @result = $query_handle->fetchrow_array();
		if(!(@result)) {
			$query = "INSERT INTO users (username, userbio) VALUES ('$NickToUpdate', '$UpdateText')";
			$query_handle = $connect->prepare($query);
			$query_handle->execute();
			$LastTime = GetTime();
			$query_handle->finish;
			$connect->disconnect();
			return $ColorCode . "Update: Inserted $NickToUpdate into archive";
		} else {
			$resultid = int($result[0]);
			$query = "UPDATE users SET username='$NickToUpdate', userbio='$UpdateText' WHERE id='$resultid'";
			$query_handle = $connect->prepare($query);
			$query_handle->execute();
			$LastTime = GetTime();
			$query_handle->finish;
			$connect->disconnect();
			return $ColorCode . "Update: Made changes to $NickToUpdate.";
		}
	}

	#!info command
	if (lc(substr($text, 0, 6)) =~ "!user ") {
		(my $command, my $NickToInfo) = split(/\s+/, $text, 2);
		if(length($NickToInfo) < 3) { $LastTime = GetTime(); return $ColorCode . "Error: View $HelpPage"; }
		if(lc($NickToInfo) eq "all") { 
			$LastTime = GetTime(); 
			return $ColorCode . "Info: On All Users Http://jkdf2.net/JKBot/JKBot.php?command=infoall"; 
		}
		$connect = DBI->connect($dsn, $user, $pw);
 		$query = "SELECT * FROM users WHERE username='$NickToInfo'";
		$query_handle = $connect->prepare($query);
		$query_handle->execute();
		my @result = $query_handle->fetchrow_array();
		if(!(@result)) {
			$LastTime = GetTime();
			$query_handle->finish;
			$connect->disconnect();
			return $ColorCode . "User: No Info Found on $NickToInfo";
		} else {
			$LastTime = GetTime();
			$query_handle->finish;
			$connect->disconnect();
			return $ColorCode . "User $NickToInfo($result[3]) - Last Seen: $result[4] - $result[2]";
		}
	}

	#!msg command
	if (lc(substr($text, 0, 5)) =~ "!msg ") {
		(my $command, my $NickToMsg, my $Msg) = split(/\s+/, $text, 3);
		if(length($NickToMsg) < 3) { $LastTime = GetTime(); return $ColorCode . "Error: View $HelpPage"; }
		if(length($Msg) < 3) { $LastTime = GetTime(); return $ColorCode . "Error: View $HelpPage"; }
		$connect = DBI->connect($dsn, $user, $pw);
		$query = "SELECT id FROM msg WHERE nicktomsg='$NickToMsg'";
		$query_handle = $connect->prepare($query);
		$query_handle->execute();
		my @result = $query_handle->fetchrow_array();
		if(!(@result)) {
			$query = "INSERT INTO msg (username, nicktomsg, message) VALUES ('$WhoSaid', '$NickToMsg', '$Msg')";
			$query_handle = $connect->prepare($query);
			$query_handle->execute();
			$LastTime = GetTime();
			$query_handle->finish;
			$connect->disconnect();
			return $ColorCode . "Msg: $WhoSaid, your message was added for $NickToMsg.";
		} else {
			$LastTime = GetTime();
			$query_handle->finish;
			$connect->disconnect();
			return $ColorCode . "Msg: This user already has a message waiting on him.";
		}
	}

	#!dmsg command
	if (lc(substr($text, 0, 6)) =~ "!dmsg ") {
		(my $command, my $NickToMsg) = split(/\s+/, $text, 2);
		if(length($NickToMsg) < 3) { $LastTime = GetTime(); return $ColorCode . "Error: View $HelpPage"; }
		$connect = DBI->connect($dsn, $user, $pw);
		$query = "SELECT * FROM msg WHERE nicktomsg='$NickToMsg'";
		$query_handle = $connect->prepare($query);
		$query_handle->execute();
		my @result = $query_handle->fetchrow_array();
		if(!(@result)) {
			$query_handle->finish;
			$connect->disconnect();	
			$LastTime = GetTime();
			#return "Msg: Nothing to delete...";
		} else {
			$query = "DELETE FROM msg WHERE nicktomsg='$NickToMsg'";
			$query_handle = $connect->prepare($query);
			$query_handle->execute();			
			$query_handle->finish;
			$connect->disconnect();	
			$LastTime = GetTime();
			return $ColorCode . "Msg: Message left for $NickToMsg was deleted.";
		}
	}

	#help command
	if (lc(substr($text, 0, 5)) =~ "!help") {
		$LastTime = GetTime();
		return $ColorCode . $HelpPage;
	}

	#AddGame Command
	if (lc(substr($text, 0, 9)) =~ "!addgame ") {
		(my $command, my $ip, my $GameInfo) = split(/\s+/, $text, 3);
		if(CheckIp($ip) eq "false") { return $ColorCode . "AddGame: Game Not Added, bad ip address. View $HelpPage"; }
		#passed ip test, lets see if game is already in progress or not.
		$connect = DBI->connect($dsn, $user, $pw);
		$query = "SELECT id FROM gamedata WHERE username='$WhoSaid'";
		$query_handle = $connect->prepare($query);
		$query_handle->execute();
		my @result = $query_handle->fetchrow_array();
		if(!(@result)) {
			$query = "INSERT INTO gamedata (username, ipaddress, gameinfo) VALUES ('$WhoSaid', '$ip', '$GameInfo')";
			$query_handle = $connect->prepare($query);
			$query_handle->execute();
			$LastTime = GetTime();
			$query_handle->finish;
			$connect->disconnect();
			return $ColorCode . "AddGame: Added $WhoSaid\'s game.";
		} else {
			$LastTime = GetTime();
			$query_handle->finish;
			$connect->disconnect();
			return $ColorCode . "AddGame: Oops, you already have a game in progress. Please remove it.";
		}
	}

	#RemoveGame Command
	if (lc(substr($text, 0, 11)) =~ "!removegame") {
		$connect = DBI->connect($dsn, $user, $pw);
		$query = "SELECT id FROM gamedata WHERE username='$WhoSaid'";
		$query_handle = $connect->prepare($query);
		$query_handle->execute();
		my @result = $query_handle->fetchrow_array();
		if(!(@result)) {
			#no game found... do nothing
			$query_handle->finish;
			$connect->disconnect();
			return;
		} else {
			$query = "DELETE FROM gamedata WHERE username='$WhoSaid'";
			$query_handle = $connect->prepare($query);
			$query_handle->execute();
			$LastTime = GetTime();
			$query_handle->finish;
			$connect->disconnect();
			return $ColorCode . "RemoveGame: Terminated $WhoSaid\'s game.";
		}
	}

	#ListGames Command
	if (lc(substr($text, 0, 10)) =~ "!listgames") {
		$connect = DBI->connect($dsn, $user, $pw);
		$query = "SELECT id FROM gamedata";
		$query_handle = $connect->prepare($query);
		$query_handle->execute();
		my @result = $query_handle->fetchrow_array();
		if(!(@result)) {
			$LastTime = GetTime();
			$query_handle->finish;
			$connect->disconnect();
			return $ColorCode . "ListGames: No games are currently being played";
		} else {
			$LastTime = GetTime();
			$query_handle->finish;
			$connect->disconnect();
			return $ColorCode . "ListGames: Http://jkdf2.net/JKBot/JKBot.php?command=listgames";
		}
	}
	#JKSTATUS Command
	if (lc(substr($text, 0, 9)) =~ "!jkstatus") {
		my $games = get "http://jkdf2.net/includes/JKBotPoll.php";
		$games =~ s/\R//g;
		$games =~ s/^\s+//;
		$LastTime = GetTime();
		return $ColorCode . $games;
		
	}
	

	#SEX COMMAND
	if (lc(substr($text, 0, 4)) =~ "!sex") {
		$connect = DBI->connect($dsn, $user, $pw);
		$query = "SELECT sexsult FROM sex ORDER BY rand() LIMIT 1";
		$query_handle = $connect->prepare($query);
		$query_handle->execute();
		my @result = $query_handle->fetchrow_array();
		my $sexjoke = $result[0];
		$LastTime = GetTime();
		$query_handle->finish;
		$connect->disconnect();
		return $ColorCode . "$WhoSaid, $sexjoke";
	}
}

sub tick {
=for comment
 my $self = shift;
		$connect = DBI->connect($dsn, $user, $pw);
		my $query = "SELECT id FROM gamedata";
		my $query_handle = $connect->prepare($query);
		$query_handle->execute();
		my @result = $query_handle->fetchrow_array();
		if(!(@result)) {
			$LastTime = GetTime();
			$query_handle->finish;
			$connect->disconnect();
			#$self->say(channel => $channel, body => "ListGames: No Games in Progress.");
		} else {
			$LastTime = GetTime();
			$query_handle->finish;
			$connect->disconnect();
			#$self->say(channel => $channel, body => "ListGames: Http://AcidShower.Com/JKBot/JKBot.php?command=listgames");
		}
=cut
return 3600;
}

# Create an instance of the bot and start it running. Connect
# to the main perl IRC server, and join some channels.
MyBot->new(
server => 'irc.gamesurge.net',
channels => [ $channel ],
nick => 'JKBot',
port => "6667",
)->run();
